## ros-kinetic-acado 1.2.2

=== CMakeLists.txt ===
################################################################################
#
# Description:
#	Main build system script for the ACADO toolkit.
#
# Authors:
#	Joel Andersson
#	Attila Kozma
#	Milan Vukov, milan.vukov@esat.kuleuven.be
#
# Year:
#	2011 - 2014.
#
# Usage:
#	- Linux, OS X, Windows: more info can be found on www.acadotoolkit.org
#
################################################################################

################################################################################
#
# Project settings
#
################################################################################

#
# Minimum required version of cmake 
#
CMAKE_MINIMUM_REQUIRED( VERSION 2.8 )

#
# Project name and programming languages used
#
PROJECT( ACADO CXX C )

#
# Project version information
#
SET( ACADO_VERSION_MAJOR  1 )
SET( ACADO_VERSION_MINOR  2 )
SET( ACADO_VERSION_PATCH  2 )
SET( ACADO_VERSION_STRING
		${ACADO_VERSION_MAJOR}.${ACADO_VERSION_MINOR}.${ACADO_VERSION_PATCH}beta
)

#
# Folder path for generated executables
#
SET( EXECUTABLE_OUTPUT_PATH ${PROJECT_BINARY_DIR}/bin )

#
# Folder path for generated libraries
#
SET( LIBRARY_OUTPUT_PATH ${PROJECT_BINARY_DIR}/lib )

#
# CMake module(s) path
#
SET( CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake" )

################################################################################
#
# User configuration
#
################################################################################

#
# Set this to true (ON) if you are using makefiles and want to see the full
# compile and link commands instead of only the shortened ones
#
IF( NOT CMAKE_VERBOSE_MAKEFILE )
	SET( CMAKE_VERBOSE_MAKEFILE OFF )
ENDIF( NOT CMAKE_VERBOSE_MAKEFILE )

#
# Enable building of shared and static libraries
#
IF ( MSVC OR CYGWIN OR MINGW )
	# All Windows builds that we currently support
	SET( ACADO_BUILD_SHARED OFF )
	SET( ACADO_BUILD_STATIC ON )
ELSE()
	# Linux or OS X
	OPTION( ACADO_BUILD_SHARED "Build shared libraries" ON )
	OPTION( ACADO_BUILD_STATIC "Build static libraries" OFF )
ENDIF()

IF((NOT ACADO_BUILD_SHARED) AND (NOT ACADO_BUILD_STATIC))
	MESSAGE( ERROR "You must build some libraries..." )
ENDIF()

#
# Enable building of ...
#
OPTION( ACADO_WITH_EXAMPLES "Building ACADO examples" ON )

#
# Compilation of testing suite
#
OPTION( ACADO_WITH_TESTING "Building the testing framework" OFF )

#
# ACADO developer flag
#
OPTION ( ACADO_DEVELOPER "Choose developer/user building mode" OFF )

#
# ACADO internal stuff
#
OPTION( ACADO_INTERNAL "Select building of ACADO internal stuff" OFF )

#
# Compile only the code generation tool
#
OPTION( ACADO_BUILD_CGT_ONLY "Build only the code generation tool" OFF )

#
# Build type
#
IF( NOT CMAKE_BUILD_TYPE )
	SET(CMAKE_BUILD_TYPE Release CACHE STRING
		"Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel."
		FORCE
	)
ENDIF( NOT CMAKE_BUILD_TYPE )

#
# Installation folders
#
SET( INSTALL_LIB_DIR lib CACHE PATH
	"Installation directory for libraries"
)
SET( INSTALL_BIN_DIR bin CACHE PATH
	"Installation directory for executables"
)
SET( INSTALL_INCLUDE_DIR include/acado CACHE PATH
	"Installation directory for header files"
)
SET( INSTALL_DATA_DIR share/acado CACHE PATH
	"Installation directory for data files"
)
SET( INSTALL_CMAKE_DIR share/acado/cmake CACHE PATH
	"Installation directory for CMake files"
)

################################################################################
#
# Dependencies
#
################################################################################

FIND_PACKAGE( Doxygen )

################################################################################
#
# Compiler settings
#
################################################################################

# Suppressing some stupid warnings from CMake 3.0
IF (POLICY CMP0026)
	CMAKE_POLICY(SET CMP0026 OLD)
ENDIF( )
IF (POLICY CMP0042)
	CMAKE_POLICY(SET CMP0042 OLD)
ENDIF( )

#
# Compiler options are in separate file
#
INCLUDE( CompilerOptions )

################################################################################
#
# Include directories
#
################################################################################

INCLUDE_DIRECTORIES(
	${PROJECT_SOURCE_DIR}
	${PROJECT_SOURCE_DIR}/acado
	${PROJECT_SOURCE_DIR}/external_packages
	${PROJECT_SOURCE_DIR}/external_packages/qpOASES-3.2.0/include
	${PROJECT_BINARY_DIR}
)

################################################################################
#
# Build the ACADO toolkit library
#
################################################################################

ADD_SUBDIRECTORY( acado )

################################################################################
#
# Building external packages
#
################################################################################

IF (NOT ACADO_BUILD_CGT_ONLY)
	#
	# Build qpOASES library
	#
	ADD_SUBDIRECTORY( ./external_packages/qpOASES-3.2.0 )
	
	#
	# Build csparse library
	#
	ADD_SUBDIRECTORY( ./external_packages/csparse )
ENDIF()

#
# Build (a part of) CasADi library
#
ADD_SUBDIRECTORY( ./external_packages/casadi )

################################################################################
#
# Automatic testing
#
################################################################################

#
# Tests
#
IF( ACADO_WITH_TESTING )
	ENABLE_TESTING()
ENDIF( ACADO_WITH_TESTING )

################################################################################
#
# Some global installation rules
#
################################################################################

#
# Install ACADO headers
#
INSTALL(
	DIRECTORY
		acado/
	DESTINATION
		${INSTALL_INCLUDE_DIR}
	FILES_MATCHING PATTERN "*.hpp"
)
INSTALL(
	DIRECTORY
		acado/
	DESTINATION
		${INSTALL_INCLUDE_DIR}
	FILES_MATCHING PATTERN "*.ipp"
)

#
# Install Eigen3
#
INSTALL(
	DIRECTORY
		external_packages/eigen3
	DESTINATION
		${INSTALL_INCLUDE_DIR}/external_packages
)

#
# Install qpOASES embedded
#
INSTALL(
	DIRECTORY
		external_packages/qpoases
	DESTINATION
		${INSTALL_DATA_DIR}/external_packages
)

#
# Configure and install CMake package configuration file
#
SET( ACADO_INSTALL_INCLUDE_DIRS
	${CMAKE_INSTALL_PREFIX}/${INSTALL_INCLUDE_DIR}
)
SET( ACADO_INSTALL_LIBRARY_DIRS
	${CMAKE_INSTALL_PREFIX}/${INSTALL_LIB_DIR}
)
SET( ACADO_INSTALL_EXTERNAL_PACKAGES_DIR
	${CMAKE_INSTALL_PREFIX}/${INSTALL_DATA_DIR}/external_packages
)
SET( ACADO_INSTALL_CMAKE_DIR
	${CMAKE_INSTALL_PREFIX}/${INSTALL_CMAKE_DIR}
)

IF ( ACADO_BUILD_STATIC )
	SET( ACADO_INSTALL_STATIC_LIBRARIES
		acado_toolkit
	)
ENDIF()

IF ( ACADO_BUILD_SHARED )
	SET( ACADO_INSTALL_SHARED_LIBRARIES
		acado_toolkit_s
	)
ENDIF()

SET( ACADO_INSTALL_QPOASES_EMBEDDED_SOURCES
	${CMAKE_INSTALL_PREFIX}/${INSTALL_DATA_DIR}/external_packages/qpoases/SRC/Bounds.cpp
	${CMAKE_INSTALL_PREFIX}/${INSTALL_DATA_DIR}/external_packages/qpoases/SRC/CyclingManager.cpp 
	${CMAKE_INSTALL_PREFIX}/${INSTALL_DATA_DIR}/external_packages/qpoases/SRC/MessageHandling.cpp
	${CMAKE_INSTALL_PREFIX}/${INSTALL_DATA_DIR}/external_packages/qpoases/SRC/QProblem.cpp
	${CMAKE_INSTALL_PREFIX}/${INSTALL_DATA_DIR}/external_packages/qpoases/SRC/Utils.cpp
	${CMAKE_INSTALL_PREFIX}/${INSTALL_DATA_DIR}/external_packages/qpoases/SRC/Constraints.cpp
	${CMAKE_INSTALL_PREFIX}/${INSTALL_DATA_DIR}/external_packages/qpoases/SRC/Indexlist.cpp	     
	${CMAKE_INSTALL_PREFIX}/${INSTALL_DATA_DIR}/external_packages/qpoases/SRC/QProblemB.cpp
	${CMAKE_INSTALL_PREFIX}/${INSTALL_DATA_DIR}/external_packages/qpoases/SRC/SubjectTo.cpp
	${CMAKE_INSTALL_PREFIX}/${INSTALL_DATA_DIR}/external_packages/qpoases/SRC/EXTRAS/SolutionAnalysis.cpp
)
SET( ACADO_INSTALL_QPOASES_EMBEDDED_INC_DIRS
	${CMAKE_INSTALL_PREFIX}/${INSTALL_DATA_DIR}/external_packages/qpoases/
	${CMAKE_INSTALL_PREFIX}/${INSTALL_DATA_DIR}/external_packages/qpoases/INCLUDE
	${CMAKE_INSTALL_PREFIX}/${INSTALL_DATA_DIR}/external_packages/qpoases/SRC
)

CONFIGURE_FILE(
	"${PROJECT_SOURCE_DIR}/cmake/ACADOConfig.cmake.in"
	"${PROJECT_BINARY_DIR}/ACADOConfig.cmake"
	@ONLY
)
INSTALL(
	FILES
		${PROJECT_BINARY_DIR}/ACADOConfig.cmake
	DESTINATION
		${INSTALL_CMAKE_DIR}
)
INSTALL(
	FILES
		${PROJECT_SOURCE_DIR}/cmake/FindACADO.cmake
		${PROJECT_SOURCE_DIR}/cmake/UseACADO.cmake
	DESTINATION
		${INSTALL_CMAKE_DIR}
)

################################################################################
#
# Rules for un-installing ACADO toolkit
#
################################################################################

CONFIGURE_FILE(
    "${CMAKE_CURRENT_SOURCE_DIR}/cmake/ACADOUninstall.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/ACADOUninstall.cmake"
    IMMEDIATE @ONLY
)

ADD_CUSTOM_TARGET( uninstall
    COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/ACADOUninstall.cmake
)

################################################################################
#
# Building API documentation
#
################################################################################

IF( DOXYGEN_FOUND )
	ADD_CUSTOM_TARGET( doc
		${DOXYGEN_EXECUTABLE} ${PROJECT_SOURCE_DIR}/doc/doxygen.config
		WORKING_DIRECTORY
			${PROJECT_SOURCE_DIR}/doc
		COMMENT
			"Generating API documentation with Doxygen" VERBATIM
	)
ENDIF( DOXYGEN_FOUND )

################################################################################
#
# Configuration of the bash script
#
################################################################################

SET( ACADO_INCLUDE_DIRS
	${PROJECT_SOURCE_DIR}
	${PROJECT_SOURCE_DIR}/acado
	${PROJECT_SOURCE_DIR}/external_packages
	${PROJECT_SOURCE_DIR}/external_packages/qpOASES-3.2.0/include
	${PROJECT_BINARY_DIR}
)

SET( ACADO_LIBRARY_DIRS
	${LIBRARY_OUTPUT_PATH}
)

SET( ACADO_EXTERNAL_PACKAGES_DIR
	${PROJECT_SOURCE_DIR}/external_packages
)

SET( ACADO_CMAKE_DIR
	${PROJECT_SOURCE_DIR}/cmake
)

SET( ACADO_STATIC_LIBRARIES 
	${ACADO_INSTALL_STATIC_LIBRARIES}
)

SET( ACADO_SHARED_LIBRARIES
	${ACADO_INSTALL_SHARED_LIBRARIES}
)

SET( ACADO_QPOASES_EMBEDDED_FOLDER 
	${PROJECT_SOURCE_DIR}/external_packages/qpoases
)

SET( ACADO_QPOASES_EMBEDDED_SOURCES
	${PROJECT_SOURCE_DIR}/external_packages/qpoases/SRC/Bounds.cpp
	${PROJECT_SOURCE_DIR}/external_packages/qpoases/SRC/CyclingManager.cpp 
	${PROJECT_SOURCE_DIR}/external_packages/qpoases/SRC/MessageHandling.cpp
	${PROJECT_SOURCE_DIR}/external_packages/qpoases/SRC/QProblem.cpp
	${PROJECT_SOURCE_DIR}/external_packages/qpoases/SRC/Utils.cpp
	${PROJECT_SOURCE_DIR}/external_packages/qpoases/SRC/Constraints.cpp
	${PROJECT_SOURCE_DIR}/external_packages/qpoases/SRC/Indexlist.cpp	     
	${PROJECT_SOURCE_DIR}/external_packages/qpoases/SRC/QProblemB.cpp
	${PROJECT_SOURCE_DIR}/external_packages/qpoases/SRC/SubjectTo.cpp
	${PROJECT_SOURCE_DIR}/external_packages/qpoases/SRC/EXTRAS/SolutionAnalysis.cpp
)

SET( ACADO_QPOASES_EMBEDDED_INC_DIRS
	${PROJECT_SOURCE_DIR}/external_packages/qpoases/
	${PROJECT_SOURCE_DIR}/external_packages/qpoases/INCLUDE
	${PROJECT_SOURCE_DIR}/external_packages/qpoases/SRC
)

CONFIGURE_FILE(
	"${PROJECT_SOURCE_DIR}/cmake/acado_env.sh.in"
	"${PROJECT_BINARY_DIR}/acado_env.sh"
	@ONLY
)

################################################################################
#
# Configure pkg-config script
#
################################################################################

SET( PC_VERSION
	${ACADO_VERSION_STRING}
)

STRING(REPLACE ";" " -I" PC_INCLUDE_DIRS "${ACADO_INCLUDE_DIRS}")
SET( PC_INCLUDE_DIRS 
	"-I${PC_INCLUDE_DIRS}"
)

STRING(REPLACE ";" " -L" PC_LIBRARY_DIRS "${ACADO_LIBRARY_DIRS}")
SET( PC_LIBRARY_DIRS
	"-L${PC_LIBRARY_DIRS}"
)

# The following code favors shared libraries.
IF ( ACADO_BUILD_SHARED )
	STRING(REPLACE ";" " -l" PC_LIBS "${ACADO_SHARED_LIBRARIES}")
ELSEIF ( ACADO_BUILD_STATIC )
	STRING(REPLACE ";" " -l" PC_LIBS "${ACADO_STATIC_LIBRARIES}")
ENDIF()
SET( PC_LIBS
	"-l${PC_LIBS}"
)

STRING(REPLACE ";" " -I" PC_QPOASES_EMBEDDED_INC_DIRS "${ACADO_QPOASES_EMBEDDED_INC_DIRS}")
SET( PC_QPOASES_EMBEDDED_INC_DIRS 
	"-I${PC_QPOASES_EMBEDDED_INC_DIRS}"
)

=== acado/CMakeLists.txt ===
################################################################################
#
# Description:
#	CMake script for building ACADO static and shared libraries, etc.
#
# Authors:
#	Milan Vukov, milan.vukov@esat.kuleuven.be
#
# Year:
#	2011 - 2014.
#
# Usage:
#	- Must be called from the main CMake script
#
################################################################################

################################################################################
#
# Configure templates
#
################################################################################

ADD_SUBDIRECTORY( code_generation/templates )

################################################################################
#
# List of source folders
#
################################################################################

SET( ACADO_SOURCE_DIRS
	# Core 
	utils
	matrix_vector
	variables_grid
	curve
	user_interaction
	symbolic_operator
	symbolic_expression
	function
)

IF (NOT ACADO_BUILD_CGT_ONLY)
	SET ( ACADO_SOURCE_DIRS ${ACADO_SOURCE_DIRS}
		# Integrators
		clock
		integrator
		set_arithmetics
		validated_integrator
		sparse_solver
		bindings/acado_csparse
		bindings/acado_gnuplot
	)
ENDIF()
	
# Optimal Control and Simulation source folders.
## Optimal Control
SET ( ACADO_SOURCE_DIRS ${ACADO_SOURCE_DIRS}
	objective
	constraint
	ocp
)

IF (NOT ACADO_BUILD_CGT_ONLY)
	SET ( ACADO_SOURCE_DIRS ${ACADO_SOURCE_DIRS}
		dynamic_system
		dynamic_discretization
		conic_program
		conic_solver
		nlp_solver
		nlp_derivative_approximation
		optimization_algorithm
		bindings/acado_qpoases
	)
ENDIF()

## Simulation
IF (NOT ACADO_BUILD_CGT_ONLY)
	SET ( ACADO_SOURCE_DIRS ${ACADO_SOURCE_DIRS}
		process
		noise
		transfer_device
		controller
		control_law
		estimator
		reference_trajectory
		simulation_environment
	)
ENDIF()

SET ( ACADO_SOURCE_DIRS ${ACADO_SOURCE_DIRS}
	# Code Generation Tool
	code_generation
	code_generation/linear_solvers	
	code_generation/integrators
)

################################################################################
#
# Building of stand-alone libraries
#
################################################################################

#
# Build ACADO Toolkit library
#
UNSET( ACADO_SOURCES )

FOREACH( DIR ${ACADO_SOURCE_DIRS} )
	FILE( GLOB SRC ${DIR}/*.cpp )
	SET( ACADO_SOURCES ${ACADO_SOURCES} ${SRC} )
ENDFOREACH( DIR ${ACADO_SOURCE_DIRS} )

IF ( ACADO_BUILD_STATIC )	
	ADD_LIBRARY( acado_toolkit STATIC ${ACADO_SOURCES} )
	TARGET_LINK_LIBRARIES(
		acado_toolkit
		acado_casadi
	)
	IF (NOT ACADO_BUILD_CGT_ONLY)
		TARGET_LINK_LIBRARIES(
			acado_toolkit
			acado_qpoases acado_csparse
		)
	ENDIF()
ENDIF ( ACADO_BUILD_STATIC )

IF( ACADO_BUILD_SHARED )
	ADD_LIBRARY( acado_toolkit_s SHARED ${ACADO_SOURCES} )
	SET_TARGET_PROPERTIES( acado_toolkit_s
		PROPERTIES
			VERSION ${ACADO_VERSION_STRING}
			SOVERSION ${ACADO_VERSION_MAJOR}
	)
	TARGET_LINK_LIBRARIES(
		acado_toolkit_s
		acado_casadi
	)
	IF (NOT ACADO_BUILD_CGT_ONLY)
		TARGET_LINK_LIBRARIES(
			acado_toolkit_s
			acado_qpoases acado_csparse
		)
	ENDIF()
ENDIF( ACADO_BUILD_SHARED )

#
# Installation rules
#
IF ( ACADO_BUILD_STATIC )
	INSTALL(
		TARGETS
			acado_toolkit
		DESTINATION
			${INSTALL_LIB_DIR}
	)
ENDIF()

IF( ACADO_BUILD_SHARED )
	INSTALL(
		TARGETS
			acado_toolkit_s
		DESTINATION
			${INSTALL_LIB_DIR}
	)
ENDIF()

################################################################################
#
# CPP lint check target
#
################################################################################

INCLUDE( CppLint )
ADD_STYLE_CHECK_TARGET(lint ${ACADO_SOURCES})

=== external_packages/csparse/CMakeLists.txt ===
#
# Project info from file cs.h
#
SET( CSPARSE_VERSION "2.2.3" )
SET( CSPARSE_SOVERSION "2" )

################################################################################
#
# Compilation of stand-alone libraries
#
################################################################################

#
# Collect all source and header files
#
FILE( GLOB CSPARSE_SOURCES *.c )
FILE( GLOB CSPARSE_HEADERS *.h )

#
# Make static & shared libraries
#
ADD_LIBRARY( acado_csparse STATIC ${CSPARSE_SOURCES} )

=== external_packages/qpoases3/Makefile ===
##
##	This file is part of qpOASES.
##
##	qpOASES -- An Implementation of the Online Active Set Strategy.
##	Copyright (C) 2007-2015 by Hans Joachim Ferreau, Andreas Potschka,
##	Christian Kirches et al. All rights reserved.
##
##	qpOASES is free software; you can redistribute it and/or
##	modify it under the terms of the GNU Lesser General Public
##	License as published by the Free Software Foundation; either
##	version 2.1 of the License, or (at your option) any later version.
##
##	qpOASES is distributed in the hope that it will be useful,
##	but WITHOUT ANY WARRANTY; without even the implied warranty of
##	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
##	See the GNU Lesser General Public License for more details.
##
##	You should have received a copy of the GNU Lesser General Public
##	License along with qpOASES; if not, write to the Free Software
##	Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
##



##
##	Filename:  Makefile
##	Author:    Hans Joachim Ferreau
##	Version:   3.1embedded
##	Date:      2007-2015
##

include make.mk

##
##	targets
##


all: src examples

src:
	@cd $@; ${MAKE} -s 

examples: src
	@cd $@; ${MAKE} -s

doc:
	@cd $@; ${MAKE} -s 

testing: src
	@cd testing/c; ${MAKE} -s

clean:
	@cd src               && ${MAKE} -s clean
	@cd examples          && ${MAKE} -s clean
	@cd bin               && ${RM} -f *.* *{EXE}
	@cd testing/c         && ${MAKE} -s clean

clobber: clean

.PHONY : all src examples doc testing clean clobber


##
##   end of file
##

=== acado/code_generation/templates/CMakeLists.txt ===
################################################################################
#
# Description:
#	Configuration of templates
#
# Authors:
#	Milan Vukov, milan.vukov@esat.kuleuven.be
# 	Rien Quirynen
#
# Year:
#	2011 - 2014
#
#
################################################################################

#
# Templates
#

SET( INTEGRATOR_MEX_TEMPLATE integrator_mex.c.in)
SET( RHS_MEX_TEMPLATE rhs_mex.c.in)

SET( HESSIAN_REG_SOURCE acado_hessian_regularization.c.in)

SET( FORCES_TEMPLATE forces_interface.in)
SET( FORCES_GENERATOR acado_forces_generator.m.in)
SET( FORCES_GENERATOR_PYTHON acado_forces_generator.py.in)
SET( QPOASES_HEADER qpoases_interface.hpp.in)
SET( QPOASES_SOURCE qpoases_interface.cpp.in)
SET( QPOASES3_HEADER qpoases3_interface.h.in)
SET( QPOASES3_SOURCE qpoases3_interface.c.in)
SET( QPDUNES_TEMPLATE qpdunes_interface.in)
SET( QPDUNES_SPLIT_TEMPLATE qpdunes_split_interface.in)

SET( AUXILIARY_FUNCTIONS_HEADER acado_auxiliary_functions.h.in)
SET( AUXILIARY_FUNCTIONS_SOURCE acado_auxiliary_functions.c.in)
SET( AUXILIARY_SIM_FUNCTIONS_HEADER acado_auxiliary_sim_functions.h.in)
SET( AUXILIARY_SIM_FUNCTIONS_SOURCE acado_auxiliary_sim_functions.c.in)
SET( SOLVER_MEX acado_solver_mex.c.in)
SET( EH_SOLVER_MEX acado_EH_solver_mex.c.in)
SET( MAKE_MEX_FORCES make_acado_solver_forces.m.in)
SET( MAKE_MEX_QPOASES make_acado_solver_qpoases.m.in)
SET( MAKE_MEX_HPMPC make_acado_solver_hpmpc.m.in)
SET( MAKE_MEX_EH_QPOASES make_acado_EH_solver_qpoases.m.in)
SET( MAKE_MEX_QPOASES3 make_acado_solver_qpoases3.m.in)
SET( MAKE_MEX_EH_QPOASES3 make_acado_EH_solver_qpoases3.m.in)
SET( MAKE_MEX_QPDUNES make_acado_solver_qpdunes.m.in)
SET( MAKE_MEX_EH_QPDUNES make_acado_EH_solver_qpdunes.m.in)
SET( MAKE_MEX_BLOCK_QPDUNES make_acado_block_solver_qpdunes.m.in)
SET( MAKE_MEX_INTEGRATOR make_acado_integrator.m.in)
SET( MAKE_MEX_MODEL make_acado_model.m.in)
SET( MAKEFILE_FORCES makefile.forces.in)
SET( MAKEFILE_QPOASES makefile.qpoases.in)
SET( MAKEFILE_QPOASES3 makefile.qpoases3.in)
SET( MAKEFILE_QPDUNES makefile.qpdunes.in)
SET( MAKEFILE_EH_QPOASES makefile.EH_qpoases.in)
SET( MAKEFILE_EH_QPDUNES makefile.EH_qpdunes.in)
SET( MAKEFILE_HPMPC makefile.hpmpc.in)
SET( MAKEFILE_INTEGRATOR makefile.integrator.in)

SET( MAKEFILE_SFUN_QPOASES make_acado_solver_sfunction.m.in)
SET( MAKEFILE_SFUN_QPOASES3 make_acado_solver_sfunction.m.in)
SET( SOLVER_SFUN_SOURCE acado_solver_sfunction.c.in)
SET( SOLVER_SFUN_HEADER acado_solver_sfunction.h.in)

SET( DUMMY_TEST_FILE dummy_test_file.in)

SET( COMMON_HEADER_TEMPLATE acado_common_header.h.in)

SET( HPMPC_INTERFACE hpmpc_interface.c.in)

#
# Template paths
#

SET( INSTALL_TEMPLATE_PATH
	${CMAKE_INSTALL_PREFIX}/${INSTALL_INCLUDE_DIR}/code_generation/templates
)

SET( TEMPLATE_PATHS ${CMAKE_CURRENT_SOURCE_DIR} ${INSTALL_TEMPLATE_PATH} )

#
# Configure templates
#

SET( CG_TEMPLATES_PATH
	${PROJECT_BINARY_DIR}/acado/code_generation/templates
)

CONFIGURE_FILE(
	"${CMAKE_CURRENT_SOURCE_DIR}/templates.hpp.in"
	"${CG_TEMPLATES_PATH}/templates.hpp"
	@ONLY
)

#
# Install templates' header
#
FILE( GLOB TEMPLATES "*.in" )

INSTALL(
	FILES
		${TEMPLATES}
		"${CG_TEMPLATES_PATH}/templates.hpp"
	DESTINATION
		${INSTALL_INCLUDE_DIR}/code_generation/templates
)

=== external_packages/qpOASES-3.2.0/doc/Makefile ===
##
##	This file is part of qpOASES.
##
##	qpOASES -- An Implementation of the Online Active Set Strategy.
##	Copyright (C) 2007-2015 by Hans Joachim Ferreau, Andreas Potschka,
##	Christian Kirches et al. All rights reserved.
##
##	qpOASES is free software; you can redistribute it and/or
##	modify it under the terms of the GNU Lesser General Public
##	License as published by the Free Software Foundation; either
##	version 2.1 of the License, or (at your option) any later version.
##
##	qpOASES is distributed in the hope that it will be useful,
##	but WITHOUT ANY WARRANTY; without even the implied warranty of
##	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
##	See the GNU Lesser General Public License for more details.
##
##	You should have received a copy of the GNU Lesser General Public
##	License along with qpOASES; if not, write to the Free Software
##	Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
##



##
##	Filename:  Makefile
##	Author:    Hans Joachim Ferreau
##	Version:   3.2
##	Date:      2007-2015
##



##
##	settings
##

MAKEPDF = pdflatex
LATEX = latex


##
##	targets
##

all: doc


.PHONY: doc
doc:
	@ echo "Creating doxygen documentation "
	@ doxygen doxygen.config
	

.PHONY: clean
clean:
	@ ${RM} -rf ./html


.PHONY: clobber
clobber: clean


##
##	end of file
##

=== external_packages/qpOASES-3.2.0/examples/Makefile ===
##
##	This file is part of qpOASES.
##
##	qpOASES -- An Implementation of the Online Active Set Strategy.
##	Copyright (C) 2007-2015 by Hans Joachim Ferreau, Andreas Potschka,
##	Christian Kirches et al. All rights reserved.
##
##	qpOASES is free software; you can redistribute it and/or
##	modify it under the terms of the GNU Lesser General Public
##	License as published by the Free Software Foundation; either
##	version 2.1 of the License, or (at your option) any later version.
##
##	qpOASES is distributed in the hope that it will be useful,
##	but WITHOUT ANY WARRANTY; without even the implied warranty of
##	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
##	See the GNU Lesser General Public License for more details.
##
##	You should have received a copy of the GNU Lesser General Public
##	License along with qpOASES; if not, write to the Free Software
##	Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
##



##
##	Filename:  examples/Makefile
##	Author:    Hans Joachim Ferreau
##	Version:   3.2
##	Date:      2007-2015
##

include ../make.mk

##
##	flags
##

IFLAGS      =  -I. \
               -I${IDIR}

QPOASES_EXES = \
	${BINDIR}/example1${EXE} \
	${BINDIR}/example1a${EXE} \
	${BINDIR}/example1b${EXE} \
	${BINDIR}/example2${EXE} \
	${BINDIR}/example3${EXE} \
	${BINDIR}/example3b${EXE} \
	${BINDIR}/example4${EXE} \
	${BINDIR}/example5${EXE} \
	${BINDIR}/exampleLP${EXE} \
	${BINDIR}/qrecipe${EXE} \
	${BINDIR}/qrecipeSchur${EXE}


##
##	targets
##

all: ${QPOASES_EXES}

${BINDIR}/%${EXE}: %.${OBJEXT} ${LINK_DEPENDS}
	@${ECHO} "Creating" $@
	@${CPP} ${DEF_TARGET} ${CPPFLAGS} $< ${QPOASES_LINK} ${LINK_LIBRARIES}

${BINDIR}/example4${EXE}: example4.${OBJEXT} example4CP.cpp ${LINK_DEPENDS}
	@${ECHO} "Creating" $@
	@${CPP} ${DEF_TARGET} ${CPPFLAGS} $< ${QPOASES_LINK} ${LINK_LIBRARIES}

${BINDIR}/qrecipe${EXE}: qrecipe.${OBJEXT} qrecipe_data.hpp ${LINK_DEPENDS}
	@${ECHO} "Creating" $@
	@${CPP} ${DEF_TARGET} ${CPPFLAGS} $< ${QPOASES_LINK} ${LINK_LIBRARIES}

${BINDIR}/qrecipeSchur${EXE}: qrecipeSchur.${OBJEXT} qrecipe_data.hpp ${LINK_DEPENDS}
	@${ECHO} "Creating" $@
	@${CPP} ${DEF_TARGET} ${CPPFLAGS} $< ${QPOASES_LINK} ${LINK_LIBRARIES}


clean:
	@${ECHO} "Cleaning up (examples)"
	@${RM} -f *.${OBJEXT} ${QPOASES_EXES}

clobber: clean


${LINK_DEPENDS}:
	@cd ..; ${MAKE} -s src

example4.${OBJEXT}: example4.cpp example4CP.cpp
	@${ECHO} "Creating" $@
	@${CPP} ${DEF_TARGET} -c ${IFLAGS} ${CPPFLAGS} $<

qrecipe.${OBJEXT}: qrecipe.cpp qrecipe_data.hpp
	@${ECHO} "Creating" $@
	@${CPP} ${DEF_TARGET} ${IFLAGS} ${CPPFLAGS} -c $<

qrecipeSchur.${OBJEXT}: qrecipeSchur.cpp qrecipe_data.hpp
	@${ECHO} "Creating" $@
	@${CPP} ${DEF_TARGET} ${IFLAGS} ${CPPFLAGS} -c $<

%.${OBJEXT}: %.cpp
	@${ECHO} "Creating" $@
	@${CPP} ${DEF_TARGET} -c ${IFLAGS} ${CPPFLAGS} $<


##
##	end of file
##

=== examples/code_generation/mpc_mhe/crane_closed_loop/CMakeLists.txt ===
################################################################################
#
# Description:
#	CMake scipt for building closed loop crane example to be used with
#	Simulink.
#
# Authors:
#	Milan Vukov, milan.vukov@esat.kuleuven.be
#
# Year:
#	2013 - 2014.
#
# Usage:
#	- This file should be called from the main CMake script for examples.
#
################################################################################

#
# Crane NMPC
#
ACADO_APPLICATION( crane_cl_nmpc crane_cl_nmpc.cpp )
ACADO_COPY_QPOASES_EMBEDDED( crane_cl_nmpc_export )

#
# Crane MHE
#
ACADO_APPLICATION( crane_cl_mhe crane_cl_mhe.cpp )
ACADO_COPY_QPOASES_EMBEDDED( crane_cl_mhe_export )

=== examples/code_generation/simulation/externModel_export/Makefile ===
#
#    This file was auto-generated by ACADO Code Generation Tool.
#    
#    ACADO Code Generation tool is a sub-package of ACADO toolkit --
#    A Toolkit for Automatic Control and Dynamic Optimization.
#    Copyright (C) 2008-2013 by Boris Houska, Hans Joachim Ferreau,
#    Milan Vukov, Rien Quirynen, KU Leuven.
#    Developed within the Optimization in Engineering Center (OPTEC)
#    under supervision of Moritz Diehl. All rights reserved.
#    
#    ACADO Toolkit is free software; you can redistribute it and/or
#    modify it under the terms of the GNU Lesser General Public
#    License as published by the Free Software Foundation; either
#    version 3 of the License, or (at your option) any later version.
#    
#    ACADO Toolkit is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#    Lesser General Public License for more details.
#    
#    You should have received a copy of the GNU Lesser General Public
#    License along with ACADO Toolkit; if not, write to the Free Software
#    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
#    

UNAME := $(shell uname)

LDLIBS = -lm -lstdc++
ifeq ($(UNAME), Linux)
	LDLIBS += -lrt
endif

CCACHE_APP := $(shell which ccache 2>/dev/null)

CFLAGS = -O3 -I.
CXXFLAGS = -O3 -finline-functions -I. 
CC     = $(CCACHE_APP) gcc
CXX    = $(CCACHE_APP) g++

OBJECTS = 	model.o \
			acado_auxiliary_sim_functions.o \
			acado_integrator.o 

.PHONY: all
all: acado_test acado_compare 

acado_test: ${OBJECTS} acado_test.o

acado_compare: ${OBJECTS} acado_compare.o

acado_auxiliary_sim_functions.o          : 	acado_common.h \
											acado_auxiliary_sim_functions.h
model.o          : 	
acado_integrator.o          : 	model.o \
								acado_common.h \
								acado_auxiliary_sim_functions.h
acado_test.o                : 	acado_common.h \
								acado_auxiliary_sim_functions.h
acado_compare.o             : 	acado_common.h \
								acado_auxiliary_sim_functions.h

${OBJECTS} : acado_auxiliary_sim_functions.h

.PHONY : clean
clean :
	-rm -f *.o *.a acado_test acado_compare

=== external_packages/qpOASES-3.2.0/interfaces/CUTEst/Makefile ===
##
##	This file is part of qpOASES.
##
##	qpOASES -- An Implementation of the Online Active Set Strategy.
##	Copyright (C) 2007-2015 by Hans Joachim Ferreau, Andreas Potschka,
##	Christian Kirches et al. All rights reserved.
##
##	qpOASES is free software; you can redistribute it and/or
##	modify it under the terms of the GNU Lesser General Public
##	License as published by the Free Software Foundation; either
##	version 2.1 of the License, or (at your option) any later version.
##
##	qpOASES is distributed in the hope that it will be useful,
##	but WITHOUT ANY WARRANTY; without even the implied warranty of
##	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
##	See the GNU Lesser General Public License for more details.
##
##	You should have received a copy of the GNU Lesser General Public
##	License along with qpOASES; if not, write to the Free Software
##	Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
##



##
##	Filename:  cutestDriver/Makefile
##	Author:    Dennis Janka
##	Version:   3.2
##	Date:      2015
##

# include directories, relative
IDIR = ../../include
SRCDIR = ../../src
BINDIR = ../../bin
CUTESTLIBPATH = ${CUTEST}/objects/${MYARCH}/double

# don't change that (for now) ...
PROBLEMPATH = ./prob

# file extensions
CPP = g++
CPPFLAGS = -Wall -pedantic -Wshadow -O0 -finline-functions -fPIC -DLINUX -g
FF = gfortran
FFLAGS =

#link against CUTEst library, qpOASES library and compiled test problem
LINKOPTS = -L${CUTESTLIBPATH} -L${PROBLEMPATH} -Wl,-rpath=${PROBLEMPATH} \
		-L${BINDIR} -Wl,-rpath=${BINDIR} -lqpOASES \
		-lcutest -llapack -lm -lgfortran -lprob

IFLAGS      = -I${IDIR} \
	      -I${CUTEST}/include

QPOASES_EXES = \
	qpoasesCutest

##
##	targets
##

all: ${QPOASES_EXES}

qpoasesCutest: qpoasesCutest.o
	@echo "Creating" $@
	${CPP} -o $@ ${CPPFLAGS} $< ${LINKOPTS}

clean:
	rm -f *.o ${QPOASES_EXES}

clobber: clean

%.o: %.cpp
	@echo "Creating" $@
	@${CPP} -c ${IFLAGS} ${CPPFLAGS} $< -o $@

##
##	end of file
##

=== external_packages/qpOASES-3.2.0/interfaces/matlab/Makefile ===
##
##	This file is part of qpOASES.
##
##	qpOASES -- An Implementation of the Online Active Set Strategy.
##	Copyright (C) 2007-2015 by Hans Joachim Ferreau, Andreas Potschka,
##	Christian Kirches et al. All rights reserved.
##
##	qpOASES is free software; you can redistribute it and/or
##	modify it under the terms of the GNU Lesser General Public
##	License as published by the Free Software Foundation; either
##	version 2.1 of the License, or (at your option) any later version.
##
##	qpOASES is distributed in the hope that it will be useful,
##	but WITHOUT ANY WARRANTY; without even the implied warranty of
##	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
##	See the GNU Lesser General Public License for more details.
##
##	You should have received a copy of the GNU Lesser General Public
##	License along with qpOASES; if not, write to the Free Software
##	Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
##



##
##	Filename:  src/interfaces/matlab/Makefile
##	Author:    Christian Kirches, Hans Joachim Ferreau, Andreas Potschka
##	Version:   3.2
##	Date:      2007-2015
##

include ../../make.mk

##
##	flags
##

IDIR   = ../../include

IFLAGS      =  -I. \
               -I${IDIR} \
               -I${MATLAB_IDIR}
			   
LINK_MATLAB_LIBS = -L${MATLAB_LIBDIR} -lmex -lmat -lmx

EXTRAFLAGS = -largeArrayDims -O -D__cpluplus -D__MATLAB__ -fexceptions

QPOASES_OBJECT = qpOASES.${OBJEXT}
QPOASES_SEQUENCE_OBJECT = qpOASES_sequence.${OBJEXT}

##
##	targets
##

all: ${BINDIR}/qpOASES.${MEXEXT} ${BINDIR}/qpOASES_sequence.${MEXEXT} copyMs

${BINDIR}/qpOASES.${MEXEXT}: ${QPOASES_OBJECT} 
	@${ECHO} "Creating" $@
	@${CPP} -shared -o $@ $? ${QPOASES_LINK} ${LINK_LIBRARIES} ${LINK_MATLAB_LIBS}

${BINDIR}/qpOASES_sequence.${MEXEXT}: ${QPOASES_SEQUENCE_OBJECT} 
	@${ECHO} "Creating" $@
	@${CPP} -shared -o $@ $? ${QPOASES_LINK} ${LINK_LIBRARIES} ${LINK_MATLAB_LIBS}

copyMs:
	@${ECHO} "Copying M files ..."
	@${CP} qpOASES.m ${BINDIR}
	@${CP} qpOASES_options.m ${BINDIR}
	@${CP} qpOASES_sequence.m ${BINDIR}

#@${CP} qpOASES_sequenceVM.m ${BINDIR}
	
clean:
	@${RM} -f *.${OBJEXT} *.mex*

clobber: clean

%.${OBJEXT}: %.cpp 
	@${ECHO} "Creating" $@
	@${CPP} ${DEF_TARGET} -c ${IFLAGS} ${EXTRAFLAGS} ${CPPFLAGS} $<


##
##	end of file
##

=== external_packages/qpOASES-3.2.0/interfaces/scilab/Makefile ===
##
##	This file is part of qpOASES.
##
##	qpOASES -- An Implementation of the Online Active Set Strategy.
##	Copyright (C) 2007-2015 by Hans Joachim Ferreau, Andreas Potschka,
##	Christian Kirches et al. All rights reserved.
##
##	qpOASES is free software; you can redistribute it and/or
##	modify it under the terms of the GNU Lesser General Public
##	License as published by the Free Software Foundation; either
##	version 2.1 of the License, or (at your option) any later version.
##
##	qpOASES is distributed in the hope that it will be useful,
##	but WITHOUT ANY WARRANTY; without even the implied warranty of
##	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
##	See the GNU Lesser General Public License for more details.
##
##	You should have received a copy of the GNU Lesser General Public
##	License along with qpOASES; if not, write to the Free Software
##	Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
##



##
##	Filename:  interfaces/scilab/Makefile
##	Author:    Holger Diedam, Hans Joachim Ferreau
##	Version:   3.2
##	Date:      2007-2015
##



PATH_LIB = .
PATH_SRC = .
PATH_OBJ = .
PATH_QPOASES_INC = ../../include
PATH_QPOASES_SRC = ../../src
PATH_QPOASES_OBJ = ../../src


##
##	bins
##

CC       = gcc
CPP      = g++
LD       = g++
CP       = cp



##
##	flags
##

CFLAGS   = -I$(PATH_QPOASES_INC) -I$(PATH_QPOASES_SRC) -Wall -pedantic -Wshadow -O3 -finline-functions -fPIC
CPPFLAGS = -I$(PATH_QPOASES_INC) -I$(PATH_QPOASES_SRC) -Wall -pedantic -Wshadow -O3 -finline-functions -fPIC -DLINUX -D__SCILAB__ -D__SINGLE_OBJECT__ 
LDFLAGS  = -shared
LIBEXT   = .so


LIB = libqpOASESinterface$(LIBEXT)

OBJ = \
	qpOASESroutines.o \
	qpOASESinterface.o



##
##	targets
##

all: $(PATH_LIB)/$(LIB)

$(PATH_OBJ)/%.o: $(PATH_SRC)/%.c
	$(CC) -c -o $(@) $(CFLAGS) $<

$(PATH_OBJ)/%.o: $(PATH_SRC)/%.cpp
	$(CPP) -c -o $(@) $(CPPFLAGS) $<

$(PATH_LIB)/$(LIB) : $(addprefix $(PATH_OBJ)/, $(OBJ))
	$(LD) $(LDFLAGS) $^ -o $@

clean:
	$(RM) $(PATH_OBJ)/*.o $(PATH_LIB)/$(LIB)



##
##	end of file
##

=== debian/changelog ===
ros-kinetic-acado (1.2.2-0xenial) xenial; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Ronald Ensing <r.m.ensing@tudelft.nl>  Mon, 11 Mar 2019 10:01:13 -0000

=== debian/control ===
Source: ros-kinetic-acado
Section: misc
Priority: extra
Maintainer: Ronald Ensing <r.m.ensing@tudelft.nl>
Build-Depends: debhelper (>= 9.0.0), cmake, libboost-all-dev
Homepage: http://acado.github.io/
Standards-Version: 3.9.2

Package: ros-kinetic-acado
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libboost-all-dev, ros-kinetic-catkin
Description: ACADO Toolkit

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/kinetic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_configure -- -DCMAKE_INSTALL_PREFIX="/opt/ros/kinetic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-kinetic-acado//opt/ros/kinetic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_install
